--
-- smoke
-- 
-- 
smoke = {};

function smoke.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function smoke:load(xmlFile)

self.smokeParticleSystems = {};
    local entry = {};
      entry.ps = {};
      Utils.loadParticleSystem(xmlFile, entry.ps, "vehicle.smokeParticleSystem", self.components, false, nil, self.baseDirectory);
      if table.getn(entry.ps) > 0 then
          entry.isActive = false;
          table.insert(self.smokeParticleSystems, entry);
      end
      local i=0;
      while true do
          local baseName = string.format("vehicle.smokeParticleSystems.smokeParticleSystem(%d)", i);
          if not hasXMLProperty(xmlFile, baseName) then
              break;
          end;
          local entry = {};
          entry.ps = {};
          Utils.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);
          if table.getn(entry.ps) > 0 then
              entry.isActive = false;
             entry.cuttingArea = i+1;
              table.insert(self.smokeParticleSystems, entry);
          end
          i = i+1;
      end;

    self.setAddedParts = SpecializationUtil.callSpecializationsFunction("setAddedParts");
	self.cardans = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cardans#index"));
	
end;

function smoke:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)

end;

function smoke:getSaveAttributesAndNodes(nodeIdent)

end;


function smoke:delete()
for _, entry in ipairs(self.smokeParticleSystems) do
          Utils.deleteParticleSystem(entry.ps);
          entry.isActive = false;
end;
   
end;


function smoke:mouseEvent(posX, posY, isDown, isUp, button)
   
end;

function smoke:keyEvent(unicode, sym, modifier, isDown)
 
end;

function smoke:readStream(streamId, connection)

end;

function smoke:writeStream(streamId, connection)

end;

function smoke:update(dt)

end;

function smoke:updateTick(dt)

 if self.isClient then
               for _,ps in pairs(self.smokeParticleSystems) do                  
                  if self.currentFillType == Fillable.FILLTYPE_MANURE and self.fillLevel > 3000 and self.movingDirection == 0 then                       
                      Utils.setEmittingState(ps.ps, true);
                  else
                      Utils.setEmittingState(ps.ps, false);
                  end
               end
 end;

end;

function smoke:draw()

end;


function smoke:setAddedParts(currentPart, noEventSend)

end;

function smoke:onAttach(attacherVehicle)
	setVisibility(self.cardans,false);	
end;

function smoke:onDetach()
	setVisibility(self.cardans,true);
end;

